using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.IO;
using System.Xml;


namespace AllLaunch
{
	/**********************************/
	/*  u܂Ƃ߂ċNṽC  */
	/**********************************/
	public partial class FormMain : Form
	{
		#region Win32API
		// 萔
		private const int SW_NORMAL = 1;
		private const int SW_MINIMIZE = 6;

		// Win32API
		[DllImport("USER32.DLL", CharSet = CharSet.Auto)]
		private static extern int ShowWindow(
			System.IntPtr hWnd,
			int nCmdShow
		);
		[DllImport("USER32.DLL", CharSet = CharSet.Auto)]
		private static extern bool SetForegroundWindow(
			System.IntPtr hWnd
		);
//		[DllImport("USER32.DLL")]
//		private static extern IntPtr GetSystemMenu(
//			IntPtr hWnd,
//			UInt32 bRevert
//		);
//		[DllImport("USER32.DLL")]
//		private static extern bool AppendMenu(
//			IntPtr hMenu,
//			UInt32 uFlags,
//			UInt32 uIDNewItem,
//			string lpNewItem
//		);
		#endregion

		// 萔
		private string XML_SOFT_PATH =							// Ǘ\tgt@C̐΃pX
			Environment.CurrentDirectory + APL.XML_SOFT_NAME;
		private string XML_CONFIG_PATH =						// ݒt@C̐΃pX
			Environment.CurrentDirectory + APL.XML_CONFIG_NAME;
		private string XML_SOFT_ELEMENT = "AllLaunch";			// \tg܂Ƃ߂XMLvf

//		// IWij[ǉ邽߂̒l
//		private const UInt32 MF_BYCOMMAND	= 0x00000000;
//		private const UInt32 MF_STRING		= 0x00000000;
//		private const UInt32 MF_SEPARATOR	= 0x00000800;

		// oϐ
		private List<SoftList>	m_softListMain 				// Ǘ\tg({)
			= new List<SoftList>(APL.MAX_TITLE_NUM);
		private Process[]	m_aryProcess;					// \tgǗ邽߂̕ϐ
		private SoftList	m_softList;						// Ǘ\tg
		private Config		m_config = new Config();		// ݒt@C̏

		private ToolStripMenuItem[] m_arySoftMenuItem;		// [\tg]̃j[e


		/****************************************************
		 * Tv  :RXgN^
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		public FormMain()
		{
			InitializeComponent();

			if(File.Exists(XML_CONFIG_PATH))
			{
				// ݒt@Cꍇ
				LoadConfigXmlFile(XML_CONFIG_PATH);
				this.TopMost = m_config.TopFront;	// tH[̍őOʐݒ
			}

			if (File.Exists(XML_SOFT_PATH))
			{
				// \tgǗt@Cꍇ
				LoadSoftXmlFile(XML_SOFT_PATH);			// ݒt@Cǂݍ
				RenewDispTitle(m_config.TitleIndex);	// \tgǗ^CgXV
			}
			else
			{	// \tgǗt@CȂԂłAk|NȂ悤ɃmۂĂ
				m_softList = new SoftList();
				m_aryProcess = new Process[0];
				m_arySoftMenuItem = new ToolStripMenuItem[0];
			}

//			/******************************************************/
//			/* ^Cgo[̉ENbNŕ\郁j[̕ύX */
//			/******************************************************/
//			// ^Cgo[̃ReLXgj[擾
//			IntPtr hMenu = GetSystemMenu(this.Handle, 0);
//
//			// Zp[^ƃj[ǉ
//			AppendMenu(hMenu, MF_SEPARATOR, 0, string.Empty);
//			AppendMenu(hMenu, MF_STRING, MF_BYCOMMAND, "o[W");
		}

		/****************************************************
		 * Tv  :\tgǗt@C
		 * ӓ_:-
		 *   :path	Ǘ\tgt@C̐΃pX
		 * ߂l:-
		****************************************************/
		private void SaveSoftXmlFile(string path)
		{
			const string errMessage = "\tgǗt@C݂̏Ɏs܂B\n\n";
			XmlTextWriter writer = null;	// xmlݗpϐ

			try
			{
				writer = new XmlTextWriter(path, Encoding.GetEncoding("UTF-8"));

				writer.Formatting = Formatting.Indented;	// vfƂɃCfgt
				writer.WriteStartDocument();				// XMLt@C1sڂݒ

				writer.WriteStartElement(XML_SOFT_ELEMENT);	// \tg̓eɂāAvfň͂
				foreach (SoftList list in m_softListMain)
				{
					list.GetXmlTextWriter(writer);				// \tg
				}
				writer.WriteEndElement();

				writer.WriteEndDocument();					// XMLt@C̍쐬
			}
			catch (XmlException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch (IOException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				if (null != writer)
				{
					writer.Close();
				}
			}
		}

		/****************************************************
		 * Tv  :ݒt@C
		 * ӓ_:-
		 *   :path	ݒt@C̐΃pX
		 * ߂l:-
		****************************************************/
		private void SaveConfigXmlFile(string path)
		{
			const string errMessage = "ݒt@C݂̏Ɏs܂B\n\n";
			XmlTextWriter writer = null;	// xmlǂݍݗpϐ

			try
			{
				writer = new XmlTextWriter(path, Encoding.GetEncoding("UTF-8"));
				m_config.GetXmlTextWriter(writer);	// eݒ
			}
			catch (XmlException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch (IOException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				if (null != writer)
				{
					writer.Close();
				}
			}
		}

		/****************************************************
		 * Tv  :\tgǗt@Cǂݍ
		 * ӓ_:-
		 *   :path	\tgǗt@C̐΃pX
		 * ߂l:-
		****************************************************/
		private void LoadSoftXmlFile(string path)
		{
			const string errMessage = "\tgǗt@C̓ǂݍ݂Ɏs܂B\n\n";
			XmlTextReader reader = null;	// xmlǂݍݗpϐ

			try
			{
				// \tgǗt@Cǂݍ݁AXV
				reader = new XmlTextReader(path);

				while(m_softListMain.Count <= APL.MAX_TITLE_NUM)
				{
					SoftList list = new SoftList();

					if(list.SetXmlTextReader(reader))
					{
						// 擾\Ȓl݂ꍇ
						m_softListMain.Add(list);
					}
					else
					{
						// 擾\ȒlȂΓǂݍݏI
						break;
					}
				}
			}
			catch (XmlException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch (IOException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				if (null != reader)
				{
					reader.Close();
				}
			}
		}

		/****************************************************
		 * Tv  :ݒt@Cǂݍ
		 * ӓ_:-
		 *   :path	ݒt@C̐΃pX
		 * ߂l:-
		****************************************************/
		private void LoadConfigXmlFile(string path)
		{
			const string errMessage = "ݒt@C̓ǂݍ݂Ɏs܂B\n\n";
			XmlTextReader reader = null;	// xmlǂݍݗpϐ

			try
			{
				// ݒt@Cǂݍ݁Am_configϐ̏XV
				reader = new XmlTextReader(path);
				m_config.SetXmlTextReader(reader);
			}
			catch (XmlException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch (IOException e)
			{
				MessageBox.Show(errMessage + e.Message, APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				if (null != reader)
				{
					reader.Close();
				}
			}
		}

		/****************************************************
		 * Tv  :j[[\tg]Ɋet@Co^
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private void EntrySoftStripMenuItem()
		{
			int i;	// [vϐ
			ToolStripMenuItem menuOpenDirectory;
			ComponentResourceManager resources = new ComponentResourceManager(typeof(FormMain));

			// [\tg]̃j[eɓo^邽߂̃oϐXV
			m_arySoftMenuItem = new ToolStripMenuItem[m_softList.Count];

			// xj[e폜āÂƓo^
			SoftStripMenuItem.DropDownItems.Clear();
			CMenuTitle.DropDownItems.Clear();

			i = 0;
			foreach (SoftItem item in m_softList)
			{
				// \tgo^
				m_arySoftMenuItem[i] = new ToolStripMenuItem(
					Path.GetFileName(item.fileName),
					Icon.ExtractAssociatedIcon(item.fileName).ToBitmap(),
					new EventHandler(SoftStripMenuItem_Click)
				);
				// j[̃CfbNXoĂ
				m_arySoftMenuItem[i].Tag = i;

				// [\tg̏ꏊJ(&F)]ǉ
				menuOpenDirectory = new ToolStripMenuItem(
					"\tg̏ꏊJ(&F)",
					(System.Drawing.Image)(resources.GetObject("OpenDirectory.Image")),
					new EventHandler(OpenDirectory_Click)
				);
				m_arySoftMenuItem[i].DropDownItems.Add(menuOpenDirectory);

				if (!notifyIcon.Visible)
				{	// Cʂ\̏ꍇ
					SoftStripMenuItem.DropDownItems.Add(m_arySoftMenuItem[i]);				// o^
				}
				else
				{	// ŏŃ^XNgCɂꍇ
					CMenuTitle.DropDownItems.Add(m_arySoftMenuItem[i]);						// o^(^XNgCp)
				}

				i++;
			}
		}

		/****************************************************
		 * Tv  :̃vZXXV
		 *       :GIMP2.8̂悤ɁANʂƃCʂĂꍇA
		 *		 :NʂƁAvZX̉ȂȂAŏȂǂ
		 *		 :łȂȂĂ܂肪ĂB̂߁Am_aryProcess
		 *		 :gpeŁA{֐ĂяoƂɂB
		 * ӓ_:A̃\tgŕ̃EBhEJĂƁA̃EBhE
		 *       :ŏłȂꍇB
		 *   :-
		 * ߂l:-
		****************************************************/
		private void UpdateResponding()
		{
			for (int i = 0; i < m_softList.Count; i++)
			{
				// xNĂȂ or \tgIƂ
				if ((null == m_aryProcess[i]) || m_aryProcess[i].HasExited) { continue; }

				// vZXȂꍇA\tgɐ؂ւ
				if (!m_aryProcess[i].Responding || ( IntPtr.Zero ==  m_aryProcess[i].MainWindowHandle ) )
				{
					m_aryProcess[i].Refresh();
				}
			}
		}

		/****************************************************
		 * Tv  :\tgN鏈
		 * ӓ_:-
		 *   :fullPathName	\tg̐΃pX
		 *		 :index			N\tg̔ԍ
		 * ߂l:-
		****************************************************/
		private void LaunchSoft(string fullPathName, int index)
		{
			try
			{
				if (File.Exists(fullPathName))
				{	// N\tg݂ꍇ

					// vZXNݒ
					ProcessStartInfo psInfo = new ProcessStartInfo(fullPathName);	// t@Cw

					psInfo.WorkingDirectory = Path.GetDirectoryName(fullPathName);	// ɂAw肵ꏊ̐ݒt@Cǂݍ

					m_aryProcess[index] = Process.Start(psInfo);	// \tgN
				}
			}
			catch (Win32Exception) {
				// ǗҌŋNɃLZƔ
				// ɃbZ[WȂǂ͕\Ȃ
			}
		}

		/****************************************************
		 * Tv  :\tgŏ鏈
		 * ӓ_:-
		 *   :processSoft	\tg̃vZX
		 * ߂l:-
		****************************************************/
		private void MinimizeSoft(Process processSoft)
		{
			// xNĂȂ or \tgIƂ
			if (null == processSoft || processSoft.HasExited) { return; }

			// AChԂł΁A\tgŏ
			if (processSoft.WaitForInputIdle(APL.MAX_WAIT_IDEL))
			{
				ShowWindow(processSoft.MainWindowHandle, SW_MINIMIZE);	// EBhEŏ
			}
		}

		/****************************************************
		 * Tv  :N{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonLaunch_Click(object sender, EventArgs e)
		{
			int i = 0;	// JEgϐ

			foreach (SoftItem item in m_softList)
			{
				if (item.launchFlag && (null == m_aryProcess[i] || m_aryProcess[i].HasExited))
				{	// {^ɂNŁAN or \tgȈꍇ
					LaunchSoft(item.fileName, i);	// \tgN
				}
				i++;
			}
		}

		/****************************************************
		 * Tv  :I{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonExit_Click(object sender, EventArgs e)
		{
			UpdateResponding();

			foreach (Process process in m_aryProcess)
			{
				// xNĂȂ or \tgIƂ
				if ((null == process) || process.HasExited) { continue; }

				if (!process.CloseMainWindow() && m_config.Kill)
				{	// IɎs  IL̏ꍇ
					process.Kill();				// I
				}
			}
		}

		/****************************************************
		 * Tv  :Oʕ\{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonFront_Click(object sender, EventArgs e)
		{
			UpdateResponding();

			foreach (Process process in m_aryProcess)
			{
				// xNĂȂ or \tgIƂ
				if (null == process || process.HasExited) { continue; }

				if (process.WaitForInputIdle(APL.MAX_WAIT_IDEL))
				{
					ShowWindow(process.MainWindowHandle, SW_NORMAL);	// EBhE\iŏj
					SetForegroundWindow(process.MainWindowHandle);		// EBhEOʕ\
				}
			}
		}

		/****************************************************
		 * Tv  :ŏ{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonMinimum_Click(object sender, EventArgs e)
		{
			UpdateResponding();

			// N̑SẴ\tgŏ
			foreach (Process process in m_aryProcess)
			{
				MinimizeSoft(process);
			}
		}

		/****************************************************
		 * Tv  :[ݒ]-[I]j[NbN
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void MenuExit_Click(object sender, EventArgs e)
		{
			Close();	// AvP[VI
		}

		/****************************************************
		 * Tv  :[ݒ]-[\tgǗ]j[NbN
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void MenuSoftManage_Click(object sender, EventArgs e)
		{
			FormSoftManage softManage;

			if (0 >= m_softListMain.Count)
			{	// \tgǗ̐ݒ肪Ȃꍇ
				softManage = new FormSoftManage();
			}
			else
			{
				// \tgǗ̐ݒ肪ꍇ́AN[쐬ĕ\ʂɐݒln
				// N[łȂƁA\tgǗʂ""ĂlXVĂ܂
				List<SoftList> softListClone = new List<SoftList>(m_softListMain.Count);
				foreach (SoftList list in m_softListMain)
				{
					softListClone.Add(list.Clone());
				}
				softManage = new FormSoftManage(softListClone, m_config.TitleIndex);
			}

			softManage.TopMost = this.TopMost;					// CʂƍőOʐݒ킹

			if (DialogResult.OK == softManage.ShowDialog())
			{
				DialogResult resultSaveSoft = DialogResult.Yes;	// ݒۑmF

				if (!IsAllSoftExited())
				{
					// ݒۑmFʂ̑I
					resultSaveSoft = MessageBox.Show(
						"ݒύXƁA݋Ñ\tgɑ΂\nI/Oʕ\/ŏ̑삪łȂȂ܂B\n\nłݒύXĂ낵łH",
						APL.TITLE,
						MessageBoxButtons.YesNo
					);
				}

				if (DialogResult.Yes == resultSaveSoft)
				{	// ݒۑꍇ
					m_softListMain = softManage.SoftList;			// XV\tg擾

					SaveSoftXmlFile(XML_SOFT_PATH);					// ݒxmlɕۑ

					RenewDispTitle(softManage.TitleIndex);			// \tgǗ^CgXV
				}
			}
		}

		/****************************************************
		 * Tv  :[ݒ]-[ݒ]j[NbN
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void MenuConfig_Click(object sender, EventArgs e)
		{
			FormConfig formConfig = new FormConfig(m_config);

			formConfig.TopMost = this.TopMost;	// őOʕ\ǂCʂƍ킹

			// ݒʂ̕\
			if (DialogResult.OK == formConfig.ShowDialog())
			{
				m_config = formConfig.GetConfig();
				this.TopMost = m_config.TopFront;				// tH[̍őOʐݒ

				// L̐ݒĺAݒŕύXȂlȂ̂ŁAŐV̒lɍXVĂ
				m_config.TitleIndex = comboTitle.SelectedIndex;	// 삷Ǘ\tg̔ԍ
			}
		}

		/****************************************************
		 * Tv  :[\tg]-[et@C]-[\tg̏ꏊJ]j[NbNƂ̏
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void OpenDirectory_Click(object sender, EventArgs e)
		{
			// I\tg̃fBNg擾
			ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;
			string DirectoryPath = Path.GetDirectoryName( m_softList.GetFileName((int)menuItem.OwnerItem.Tag) );

			// fBNg\
			Process.Start(DirectoryPath);
		}

		/****************************************************
		 * Tv  :[\tg]-[et@C]j[NbNƂ̏
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void SoftStripMenuItem_Click(object sender, EventArgs e)
		{
			ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;			// NbNڏ擾

			if(!menuItem.Checked)
			{
				// ǂ̍ڂNbN̂擾
				int indexMenuItem = (int)menuItem.Tag;
				string fullPathName = m_softList.GetFileName(indexMenuItem);

				LaunchSoft(fullPathName, indexMenuItem);	// \tgN
			}
		}

		/****************************************************
		 * Tv  :R{{bNX̃^CgXV
		 * ӓ_:-
		 *   :viewIndex	R{{bNX̃CfbNX
		 * ߂l:-
		****************************************************/
		private void RenewDispTitle(int viewIndex)
		{
			if (0 >= m_softListMain.Count)
			{	// ݒt@C̓ǂݍ݂ɎsƂȂ
				return;
			}

			// R{{bNX̃^CgXV
			comboTitle.Items.Clear();				// xAeSăNA
			foreach (SoftList list in m_softListMain)
			{
				comboTitle.Items.Add(list.Title);	// ^Cgǉ
			}

			// hbv_EXg̉XV
			int maxDropDownWidth = comboTitle.Width;
			foreach (string title in comboTitle.Items)
			{
				// hbv_EXg̉擾
				maxDropDownWidth = Math.Max(maxDropDownWidth,
					TextRenderer.MeasureText(title, comboTitle.Font).Width);
			}
			// combobox̉菬lݒ肵ĂAcombobox̉ƓɂȂ
			comboTitle.DropDownWidth = maxDropDownWidth;

			// \vfݒ
			if ((0 <= viewIndex) && (viewIndex < comboTitle.Items.Count))
			{
				comboTitle.SelectedIndex = viewIndex;
			}
			else
			{	// ͈͊O̒lݒ肳ꂻɂȂƂ
				comboTitle.SelectedIndex = 0;
			}

			// 삷Ǘ\tg̔ԍiݒjXV
			m_config.TitleIndex = comboTitle.SelectedIndex;

			// 삷\tgXV
			m_softList = m_softListMain[m_config.TitleIndex];

			// 삷\tg̐ɉămہiǗZbgj
			m_aryProcess = new Process[m_softList.Count];

			// [\tg]Ɋet@Co^
			EntrySoftStripMenuItem();

			CMenuTitle.Text = m_softList.Title;	// ENbNj[ɕ\^Cg
		}

		/****************************************************
		 * Tv  :Cʂ̃TCYύXꂽꍇ
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void FormMain_Resize(object sender, EventArgs e)
		{
			if ((FormWindowState.Minimized == this.WindowState) &&
				(m_config.TaskTray))
			{	// ^XNgC풓ōŏꂽꍇ
				this.Visible = false;		// tH[\ɂ
				notifyIcon.Visible = true;	// ^XNgCɃACR\

				// ^XNgCp̃j[Ɋe\tgNp̍ڂǉ
				foreach (ToolStripMenuItem item in m_arySoftMenuItem)
				{
					CMenuTitle.DropDownItems.Add(item);	// o^(^XNgCp)
				}
			}
		}

		/****************************************************
		 * Tv  :ǗĂ\tgSĕĂ邱ƂmF
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private bool IsAllSoftExited()
		{
			// ߂lԂ(true:\tgSĕĂAfalse:ł\tgN)
			foreach (Process item in m_aryProcess)
			{
				if (null != item)
				{
					if (!item.HasExited)
					{
						return false;
					}
				}
			}

			return true;
		}

		/****************************************************
		 * Tv  :Cʂ钼Ȍ
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			CxgɊւf[^
		 * ߂l:-
		****************************************************/
		private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
		{
			bool flgAplCloseing = true;	// AvP[VItO

			if (!IsAllSoftExited())
			{	// Ñ\tgLꍇ

				// ImFʂ̑I
				DialogResult closingCheckResult = MessageBox.Show(
					"܂Ñ\tg܂BIĂ낵łH",
					APL.TITLE,
					MessageBoxButtons.YesNo
				);

				if (DialogResult.No == closingCheckResult)
				{	// ILZꍇ
					e.Cancel = true;
					flgAplCloseing = false;
				}
			}

			if (flgAplCloseing)
			{	// AvP[VIꍇ
				notifyIcon.Visible = false;				// ^XNgC̃ACR\

				SaveConfigXmlFile(XML_CONFIG_PATH);		// ݒt@C
			}
		}

		/****************************************************
		 * Tv  :^XNgC̃ACR_uNbNƂ
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void notifyIcon_DoubleClick(object sender, EventArgs e)
		{
			this.Visible = true;						// tH[\
			notifyIcon.Visible = false;					// ^XNgC̃ACR\

			// ʏ탁j[Ɋe\tgNp̍ڂǉ
			foreach (ToolStripMenuItem item in m_arySoftMenuItem)
			{
				SoftStripMenuItem.DropDownItems.Add(item);	// o^
			}

			// tH[Oʂɏo
			this.WindowState = FormWindowState.Normal;
			this.Activate();
		}

		/****************************************************
		 * Tv  :[\tg]j[JƂA`FbNԂXV
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void SoftStripMenuItem_DropDownOpened(object sender, EventArgs e)
		{
			for(int i = 0; i < m_softList.Count; i++)
			{
				if ((null == m_aryProcess[i]) || m_aryProcess[i].HasExited)
				{	// AvP[VȈꍇ
					m_arySoftMenuItem[i].Checked = false;
				}
				else
				{	// AvP[Vs̏ꍇ
					m_arySoftMenuItem[i].Checked = true;
				}
			}
		}

		/****************************************************
		 * Tv  :{̋NɃ\tgN鏈
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private void StartUpLaunch()
		{
			if (!m_config.StartUpLaunch)
			{
				// NȂΏI
				return;
			}

			int i = 0;	// JEgϐ

			foreach (SoftItem item in m_softList)
			{
				if (item.launchFlag && (null == m_aryProcess[i] || m_aryProcess[i].HasExited))
				{	// {^ɂNŁAN or \tgȈꍇ
					LaunchSoft(item.fileName, i);	// \tgN

					if (m_config.StartUpLaunchMin)
					{
						MinimizeSoft(m_aryProcess[i]);
					}
				}
				i++;
			}
		}

		/****************************************************
		 * Tv  :Cʂ\钼Ȍ
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private void FormMain_Load(object sender, EventArgs e)
		{
			// {̋NɃ\tgN
			StartUpLaunch();
		}

		/****************************************************
		 * Tv  :Cʂ\̏
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private void FormMain_Shown(object sender, EventArgs e)
		{
			if (m_config.TaskTray && m_config.StartUpTray)
			{
				// NɃ^XNgC풓
				this.WindowState = FormWindowState.Minimized;
			}
		}

		private void comboTitle_SelectedIndexCommitted(object sender, EventArgs e)
		{
			if ((0 > comboTitle.SelectedIndex) || (m_softListMain.Count <= comboTitle.SelectedIndex))
			{
				// ȔԍIĂI
				return;
			}

			if (DialogResult.Yes == CheckSoftListChanged("삷\tg"))
			{
				// SẴ\tgIĂꍇ
				RenewDispTitle(comboTitle.SelectedIndex);
			}
			else
			{
				// ߂
				comboTitle.SelectedIndex = m_config.TitleIndex;
			}
		}

		/****************************************************
		 * Tv  :{̋NɃ\tgN鏈
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private DialogResult CheckSoftListChanged(string changeReason)
		{
			DialogResult resultSaveSoft = DialogResult.Yes;	// ݒۑmF

			if (!IsAllSoftExited())
			{
				// ݒۑmFʂ̑I
				resultSaveSoft = MessageBox.Show(
					changeReason + "ύXƁA݋Ñ\tgɑ΂\n" +
					"I/Oʕ\/ŏ̑삪łȂȂ܂B" +
					"\n\nłݒύXĂ낵łH",
					APL.TITLE,
					MessageBoxButtons.YesNo
				);
			}

			return resultSaveSoft;
		}
	}
}