using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace AllLaunch
{
	/********************/
	/*  \tgǗ  */
	/********************/
	public partial class FormSoftManage : Form
	{
		// 萔
		public const int MAX_TITLE_BYTE = 28;

		// oϐ
		private List<SoftList>	m_softListMain;	// Ǘ\tgW
		private SoftList		m_softList;		// Ǘ\tgP
		private int m_titleSelectedIndex;
		private int m_indexFromPoint = -1;		// CheckedListBoxŃ}EXWɑ΂CfbNX

		// ݒ肵\tg擾
		public List<SoftList> SoftList
		{
			get
			{
				return m_softListMain;
			}
		}

		public int TitleIndex
		{
			get
			{
				return m_titleSelectedIndex;
			}
		}

		/****************************************************
		 * Tv  :RXgN^
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		public FormSoftManage()
		{
			InitializeComponent();

			m_softListMain = new List<SoftList>(APL.MAX_TITLE_NUM);
			m_softListMain.Add(new SoftList());

			// \tg񂪂Ȃꍇ́Ã\tg1ǉĂ
			comboTitle.Items.Add("");
			comboTitle.SelectedIndex = 0;

			UpdateButtonEnabled();	// {^\XV
		}

		/****************************************************
		 * Tv  :RXgN^
		 * ӓ_:-
		 *   :inSoftList	\tgǗ
		 * ߂l:-
		****************************************************/
		public FormSoftManage(List<SoftList> inSoftList, int titleIndex)
		{
			System.Diagnostics.Debug.Assert(null != inSoftList);

			InitializeComponent();

			m_softListMain = inSoftList;

			if (0 < m_softListMain.Count)
			{
				// \tg񂪂ꍇ
				// ^CgXV
				foreach (SoftList list in m_softListMain)
				{
					comboTitle.Items.Add(list.Title);
				}
				if (m_softListMain.Count > titleIndex)
				{
					comboTitle.SelectedIndex = titleIndex;
				}
				else
				{
					comboTitle.SelectedIndex = 0;
				}

				// e\tgXg{bNXeɂẮAcomboTitle_SelectedIndexChanged֐Ŏs
			}
			else
			{
				// \tg񂪂Ȃꍇ́Ã\tg1ǉĂ
				comboTitle.Items.Add("");
				comboTitle.SelectedIndex = 0;
			}

			UpdateButtonEnabled();	// {^\XV
		}

		/****************************************************
		 * Tv  :{^\XV
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		private void UpdateButtonEnabled()
		{
			// ő吔ɒBAo^{^Ȃ悤ɂ
			buttonEntrySoft.Enabled = (APL.MAX_LIST_NUM > checkedList.Items.Count);
			// Ǘ\tgȂȂA폜{^Ȃ
			buttonDeleteSoft.Enabled = (0 < checkedList.Items.Count);
		}

		/****************************************************
		 * Tv  :o^{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonEntrySoft_Click(object sender, EventArgs e)
		{
			OpenFileDialog openFile = new OpenFileDialog();

			if (DialogResult.OK == openFile.ShowDialog())
			{
				m_softList.Add(true, openFile.FileName);
				checkedList.Items.Add(Path.GetFileName(openFile.FileName), true);
			}

			UpdateButtonEnabled();	// {^\XV
		}

		/****************************************************
		 * Tv  :폜{^
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void buttonDeleteSoft_Click(object sender, EventArgs e)
		{
			int selectedIndex = checkedList.SelectedIndex;	// ICfbNX

			if (0 <= selectedIndex)
			{
				m_softList.Remove(selectedIndex);
				checkedList.Items.RemoveAt(selectedIndex);

				// 폜ƁA߂CfbNXőIԂɂ
				if (selectedIndex < checkedList.Items.Count)
				{
					checkedList.SelectedIndex = selectedIndex;
				}
				else if (0 < selectedIndex)
				{
					checkedList.SelectedIndex = selectedIndex - 1;
				}
				else
				{
					// ȂiIł`FbNȂԁj
				}
			}
			else
			{
				MessageBox.Show("폜\tg̃XgIĂ",
					APL.TITLE, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}

			UpdateButtonEnabled();	// {^\XV
		}

		/****************************************************
		 * Tv  :R{{bNX̃^CgXVƂ
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			ɈӖȂ
		 * ߂l:-
		****************************************************/
		private void comboTitle_Validated(object sender, EventArgs e)
		{
			// ͂^CgύXꂽƂɍXV
			if (m_softList.Title != comboTitle.Text)
			{
				m_softList.Title = comboTitle.Text;
				comboTitle.Items[m_titleSelectedIndex] = m_softList.Title;
			}
		}

		/****************************************************
		 * Tv  :N`FbNύXꍇ
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			Xg{bNX̃`FbN
		 * ߂l:-
		****************************************************/
		private void checkedList_ItemCheck(object sender, ItemCheckEventArgs e)
		{
			switch (e.NewValue)
			{
				case CheckState.Checked:	// `FbNƂ
					m_softList.SetLaunchFlag(e.Index, true);
					break;
				case CheckState.Unchecked:	// `FbNOƂ
					m_softList.SetLaunchFlag(e.Index, false);
					break;
				default:					// ̑
					break;
			}
		}

		/****************************************************
		 * Tv  :c[`bvA\tg̃tpX\
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			}EX̓Ɋւ
		 * ߂l:-
		****************************************************/
		private void checkedList_MouseMove(object sender, MouseEventArgs e)
		{
			int index = checkedList.IndexFromPoint(e.X, e.Y);	// ݂̃}EXWɂCfbNX

			if (m_indexFromPoint != index)
			{	// }EXʒũCfbNXɕύXꍇ
				m_indexFromPoint = index;										// CfbNXXV
				toolTip.SetToolTip(checkedList, m_softList.GetFileName(index));	// c[`bv\
			}
		}

		/****************************************************
		 * Tv  :Ǘ\tgǉƂ̏
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			}EX̓Ɋւ
		 * ߂l:-
		****************************************************/
		private void buttonAddTitle_Click(object sender, EventArgs e)
		{
			// \tgǉ
			// ^CgɒǉȂƁAcomboTitle_SelectedIndexChanged֐Ă΂ăk|ƂȂ
			m_softListMain.Add(new SoftList());

			// ^Cgǉ
			comboTitle.Items.Add("");
			comboTitle.SelectedIndex = comboTitle.Items.Count-1;
		}

		/****************************************************
		 * Tv  :^CgpR{{bNX̃CfbNXύXꂽƂɌĂяo
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			}EX̓Ɋւ
		 * ߂l:-
		****************************************************/
		private void comboTitle_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (0 > comboTitle.SelectedIndex)
			{
				// ȃCfgl̏ꍇ
				return;
			}
			m_titleSelectedIndex = comboTitle.SelectedIndex;	// ݑIĂԍ擾

			// ő吔ɒBA\tgo^{^Ȃ悤ɂ
			buttonAddTitle.Enabled = (APL.MAX_TITLE_NUM > comboTitle.Items.Count);

			// \tg0ɂȂ߁A\tg폜{^𐧌
			buttonRemoveTitle.Enabled = (1 < comboTitle.Items.Count);

			// \񃊃Xgݒ
			m_softList = m_softListMain[m_titleSelectedIndex];

			// Xg{bNX̓eXV
			checkedList.Items.Clear();
			foreach (SoftItem item in m_softList)
			{
				checkedList.Items.Add(Path.GetFileName(item.fileName), item.launchFlag);
			}
		}

		/****************************************************
		 * Tv  :Ǘ\tg폜Ƃ̏
		 * ӓ_:-
		 *   :sender	CxgIuWFNg
		 *		 :e			}EX̓Ɋւ
		 * ߂l:-
		****************************************************/
		private void buttonRemoveTitle_Click(object sender, EventArgs e)
		{
			DialogResult result = MessageBox.Show(
				"ݕ\ĂǗ\tg폜܂A낵łH",
				"폜̊mF",
				MessageBoxButtons.YesNo,
				MessageBoxIcon.Exclamation);

			if (DialogResult.No == result)
			{
				// 폜ۂꂽꍇA𒆎~
				return;
			}

			// \tg폜
			// ^CgɒǉȂƁAcomboTitle_SelectedIndexChanged֐Ă΂ăk|ƂȂ
			m_softListMain.RemoveAt(m_titleSelectedIndex);

			// ^Cg폜
			comboTitle.Items.RemoveAt(m_titleSelectedIndex);

			// 폜ƁA߂CfbNXőIԂɂ
			if (m_titleSelectedIndex < comboTitle.Items.Count)
			{
				comboTitle.SelectedIndex = m_titleSelectedIndex;
			}
			else if (0 < m_titleSelectedIndex)
			{
				comboTitle.SelectedIndex = m_titleSelectedIndex - 1;
			}
			else
			{
				// ȂiIł`FbNȂԁj
			}
		}

		/****************************************************
		 * Tv  :͂^Cg̒𐧌
		 * ӓ_:Rsyɂ͑ΉłĂȂ
		 *   :sender	CxgIuWFNg
		 *		 :e			}EX̓Ɋւ
		 * ߂l:-
		****************************************************/
/*		private void comboTitle_KeyPress(object sender, KeyPressEventArgs e)
		{
			int titleByteCount = Encoding.GetEncoding("Shift_JIS").GetByteCount(comboTitle.Text);

			if ((MAX_TITLE_BYTE <= titleByteCount) && (char.IsLetterOrDigit(e.KeyChar)))														
			{
				// ^Cg̃oCgőlȏ  ͕At@xbg܂10ȉꍇ
				e.KeyChar = '\0';
			}
		}
*/
	}

	/**************************/
	/*  Ǘ\tg̏  */
	/**************************/
	public class SoftItem
	{
		// 萔
		public const string XML_ELEMENT		= "FileName";
		public const string XML_ATTRIBUTE	= "LaunchFlag";

		// oϐ
		public bool		launchFlag;	// NtO(true:{^ŋN)
		public string	fileName;	// t@Ci΃pXƊgq܂ށj

		// RXgN^
		public SoftItem() { }
		public SoftItem(bool inLaunchFlag, string inFileName)
		{
			launchFlag = inLaunchFlag;
			fileName = inFileName;
		}

		/****************************************************
		 * Tv  :t@C̏ݗpvf쐬
		 * ӓ_:-
		 *   :writer	xml
		 * ߂l:-
		****************************************************/
		public void GetXml(XmlTextWriter writer)
		{
			writer.WriteStartElement(XML_ELEMENT);								// vf(FileName)쐬Jn
			writer.WriteAttributeString(XML_ATTRIBUTE, launchFlag.ToString());	// NtOǉ
			writer.WriteString(fileName);										// t@Cǉ
			writer.WriteEndElement();											// vf쐬
		}

		/****************************************************
		 * Tv  :󂯎XmlTextReaderA\tg̏擾
		 * ӓ_:O͏ʂŎ{
		 *   :reader		ǂݍxmlt@C̏
		 *		 :flgExistFile	t@C̑ݗL(true:݂Afalse:݂Ȃ)
		 * ߂l:-
		****************************************************/
		public void SetXml(XmlTextReader reader, ref bool flgExistFile)
		{
			// \tgǂݍޑÓAt@C݂Ȃ̂Ƃ
			flgExistFile = false;

			do
			{	// ݂readeȑԂǂݍނ̂ŁAdo-whileɂĂ
				switch (reader.NodeType)
				{
					case XmlNodeType.Element:
						if (reader.MoveToFirstAttribute())
						{
							// NtO擾
							launchFlag = bool.Parse(reader.Value);
						}
						break;
					case XmlNodeType.Text:
						// t@C擾
						fileName = reader.Value;
						flgExistFile = File.Exists(fileName);
						break;
					case XmlNodeType.EndElement:
						// ǂݎ肪̂ŁA֐𔲂
						return;
					default:
						// Ȃ
						break;
				}
			} while (reader.Read());	// ̃t@C̃m[hֈړ
		}

		#region XmlDocumentɂt@Cǂݏ
		/*
		// xmlt@Cɕۑvf쐬
		public XmlElement GetXml(XmlDocument doc)
		{
			// t@C̗vf쐬
			XmlElement node = doc.CreateElement("FileName");

			node.SetAttribute("LaunchFlag", launchFlag.ToString());	// NtOݒ
			node.AppendChild(doc.CreateTextNode(fileName));			// t@Cݒ

			return node;
		}

		// xmlt@Cǂݍ񂾗vfɂlݒ
		public void  SetXml(XmlElement node)
		{
			// NtO擾
			launchFlag = bool.Parse(node.GetAttribute("LaunchFlag"));
			// t@C擾
			fileName = node.FirstChild.Value;
		}
		*/
		#endregion
	}

	/********************************/
	/*  Ǘ\tg̏񃊃Xg  */
	/********************************/
	public class SoftList
	{
		// 萔
		private const string XML_ELEMENT = "SoftManage";
		private const string XML_ATTRIBUTE = "Title";

		// oϐ
		private string			m_title = "";									// Ǘ\tgW̃^Cg
		private	List<SoftItem>	m_items = new List<SoftItem>(APL.MAX_LIST_NUM);	// Ǘ\tg̃Xg

		// Ǘ\tgW̃^Cg擾Aݒ
		public string Title
		{
			get
			{
				return m_title;
			}
			set
			{
				m_title = value;
			}
		}

		// o^\tg̐擾
		public int Count
		{
			get
			{
				return m_items.Count;
			}
		}

		/****************************************************
		 * Tv  :Ǘ\tgǉ
		 * ӓ_:-
		 *   :inLaunchFlag	NtO
		 *		 :inFileName	t@C
		 * ߂l:-
		****************************************************/
		public void Add(bool inLaunchFlag, string inFileName)
		{
			m_items.Add(new SoftItem(inLaunchFlag, inFileName));
		}

		/****************************************************
		 * Tv  :Ǘ\tg폜
		 * ӓ_:-
		 *   :index	폜ԍ
		 * ߂l:-
		****************************************************/
		public void Remove(int index)
		{
			if ((0 <= index) && (index < m_items.Count))
			{	// ͈͓̃CfbNXw肳ꂽꍇA\tg폜
				m_items.RemoveAt(index);
			}
		}

		/****************************************************
		 * Tv  :N[֐ŁARs[擾
		 * ӓ_:-
		 *   :-
		 * ߂l:-
		****************************************************/
		public SoftList Clone()
		{
			SoftList tempSoftList = new SoftList();	// Rs[pϐ

			// Ǘ\tgW̃^Cg
			tempSoftList.Title = string.Copy(m_title);

			// Ǘ\tg̃Xg
			foreach(SoftItem item in m_items)
			{
				tempSoftList.Add(item.launchFlag, item.fileName);
			}

			return tempSoftList;
		}

		/****************************************************
		 * Tv  :NtOݒ肷
		 * ӓ_:-
		 *   :index	ݒύXNtO̔ԍ
		 *		 :flag	ݒ肷l
		 * ߂l:-
		****************************************************/
		public void SetLaunchFlag(int index, bool flag)
		{
			if ((0 <= index) && (index < m_items.Count))
			{	// ͈͓̃CfbNXw肳ꂽꍇAtOύX
				m_items[index].launchFlag = flag;
			}
		}

		/****************************************************
		 * Tv  :t@C(tpX)擾
		 * ӓ_:-
		 *   :index	\tpXԍ
		 * ߂l:-
		****************************************************/
		public string GetFileName(int index)
		{
			string fileName = "";

			if ((0 <= index) && (index < m_items.Count))
			{	// ͈͓̃CfbNXw肳ꂽꍇAt@CԂ
				fileName = m_items[index].fileName;
			}

			return fileName;
		}

		// Xg̊evfforeachŎ擾ł悤ɂ
		public IEnumerator<SoftItem> GetEnumerator()
		{
			foreach (SoftItem item in m_items)
			{
				yield return item;
			}
		}

		/****************************************************
		 * Tv  :ۑxmlt@C񂪏܂ꂽXmlTextReadero͂
		 * ӓ_:-
		 *   :writer	xml
		 * ߂l:-
		****************************************************/
		public void GetXmlTextWriter(XmlTextWriter writer)
		{
			writer.WriteStartElement(XML_ELEMENT);					// vf(SoftManage)쐬Jn
			writer.WriteAttributeString(XML_ATTRIBUTE, m_title);	// ^Cgǉ

			// evf(FileName)ǉ
			foreach (SoftItem item in m_items)
			{
				item.GetXml(writer);
			}

			writer.WriteEndElement();								// vf쐬
		}

		/****************************************************
		 * Tv  :󂯎XmlTextReaderAǗ\tg̏擾
		 * ӓ_:O͏ʂŎ{
		 *   :reader	ǂݍxmlt@C̏
		 * ߂l:ǂݎl݂ۂ
		****************************************************/
		public bool SetXmlTextReader(XmlTextReader reader)
		{
			bool ret = false;	// ߂l

			while (reader.Read())
			{
				// ǂݎvfꍇ
				switch (reader.NodeType)
				{
					case XmlNodeType.Element:
						ret = true;
						SetVariableByElementName(reader.Name, reader);
						break;
					case XmlNodeType.EndElement:
						// ǂݎ肪̂ŁAI
						return ret;
					// case XmlDeclaration:	// XML 錾 ( : <?xml version='1.0'?>)
					// case Whitespace:		// 󔒁As
					default:
						break;
				}
			}

			return ret;
		}

		/****************************************************
		 * Tv  :vfɑ΂ϐɒlݒ肷
		 * ӓ_:
		 *   :elementName	vf
		 *		 :reader		ǂݍxmlt@C̏
		 * ߂l:-
		****************************************************/
		private void SetVariableByElementName(string elementName, XmlTextReader reader)
		{
			switch (elementName)
			{
				case XML_ELEMENT:
					if (reader.MoveToFirstAttribute())
					{	// vf̑A^Cg擾
						m_title = reader.Value;
					}
					break;
				case SoftItem.XML_ELEMENT:
					// \tg擾
					SoftItem item = new SoftItem();
					bool flgExistFile = new bool();
					item.SetXml(reader, ref flgExistFile);

					// t@Ĉ݂łꍇ̂݁A\tgǉ
					if (flgExistFile)
					{
						m_items.Add(item);
					}
					break;
				default:
					// Ȃ
					break;
			}
		}

		#region XmlDocumentɂt@Cǂݏ
		/*
		// xmlt@CɊǗ\tg̏ۑ
		public void SaveXmlFile(string path)
		{
			XmlDocument doc = new XmlDocument();

			doc.AppendChild(doc.CreateXmlDeclaration("1.0", "UTF-8", null));

			XmlElement root = doc.CreateElement("AllLaunch");
			doc.AppendChild(root);

			XmlElement manageNode = doc.CreateElement("SoftManage");
			manageNode.SetAttribute("title", m_title);
			root.AppendChild(manageNode);

			// ׂẴ\tgǉ
			foreach(SoftItem item in m_items) {
				manageNode.AppendChild(item.GetXml(doc));
			}

			doc.Save(path);
		}

		// xmlt@Cǂݍ݁AǗ\tg̏擾
		public void LoadXmlFile(string path)
		{
			XmlDocument doc = new XmlDocument();
			
			doc.Load(path);

			XmlElement root = (XmlElement)doc.DocumentElement.FirstChild;
			m_title = root.GetAttribute("title");	// ^Cg擾

			m_items.Clear();								// ׂẴ\tg폜

			// xmlt@Cǂݎ\tgǉ
			for(XmlNode node = root.FirstChild; node != null; node = node.NextSibling) {
				SoftItem item = new SoftItem();
				item.SetXml((XmlElement)node);
				m_items.Add(item);
			}
		}
		*/
		#endregion
	}
}